"All.ASCII" <-
c("", "\001", "\002", "\003", "\004", "\005", "\006", "\007", "\b", "\t", "\n",
  "\013", "\014", "\r", "\016", "\017", "\020", "\021", "\022", "\023",
  "\024", "\025", "\026", "\027", "\030", "\031", "\032", "\033", "\034",
  "\035", "\036", "\037", " ", "!", "\"", "#", "$", "%", "&", "'", "(",
  ")", "*", "+", ",", "-", ".", "/", "0", "1", "2", "3", "4", "5", "6",
  "7", "8", "9", ":", ";", "<", "=", ">", "?", "@", "A", "B", "C", "D",
  "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R",
  "S", "T", "U", "V", "W", "X", "Y", "Z", "[", "\\", "]", "^", "_", "`",
  "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n",
  "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "{", "|",
  "}", "~", "\177", "\200", "\201", "\202", "\203", "\204", "\205",
  "\206", "\207", "\210", "\211", "\212", "\213", "\214", "\215", "\216",
  "\217", "\220", "\221", "\222", "\223", "\224", "\225", "\226", "\227",
  "\230", "\231", "\232", "\233", "\234", "\235", "\236", "\237", "\240",
  "\241", "\242", "\243", "\244", "\245", "\246", "\247", "\250", "\251",
  "\252", "\253", "\254", "\255", "\256", "\257", "\260", "\261", "\262",
  "\263", "\264", "\265", "\266", "\267", "\270", "\271", "\272", "\273",
  "\274", "\275", "\276", "\277", "\300", "\301", "\302", "\303", "\304",
  "\305", "\306", "\307", "\310", "\311", "\312", "\313", "\314", "\315",
  "\316", "\317", "\320", "\321", "\322", "\323", "\324", "\325", "\326",
  "\327", "\330", "\331", "\332", "\333", "\334", "\335", "\336", "\337",
  "\340", "\341", "\342", "\343", "\344", "\345", "\346", "\347", "\350",
  "\351", "\352", "\353", "\354", "\355", "\356", "\357", "\360", "\361",
  "\362", "\363", "\364", "\365", "\366", "\367", "\370", "\371", "\372",
  "\373", "\374", "\375", "\376", "\377")

"All.ASCII.rep" <-
c("", "\\001", "\\002", "\\003", "\\004", "\\005", "\\006", "\\007", "\\b",
  "\\t", "\\n", "\\013", "\\014", "\\r", "\\016", "\\017", "\\020",
  "\\021", "\\022", "\\023", "\\024", "\\025", "\\026", "\\027", "\\030",
  "\\031", "\\032", "\\033", "\\034", "\\035", "\\036", "\\037", " ",
  "!", "\\\"", "#", "$", "%", "&", "'", "(", ")", "*", "+", ",", "-",
  ".", "/", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ":", ";",
  "<", "=", ">", "?", "@", "A", "B", "C", "D", "E", "F", "G", "H", "I",
  "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W",
  "X", "Y", "Z", "[", "\\", "]", "^", "_", "`", "a", "b", "c", "d", "e",
  "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s",
  "t", "u", "v", "w", "x", "y", "z", "{", "|", "}", "~", "\\177", "\\200",
  "\\201", "\\202", "\\203", "\\204", "\\205", "\\206", "\\207", "\\210",
  "\\211", "\\212", "\\213", "\\214", "\\215", "\\216", "\\217", "\\220",
  "\\221", "\\222", "\\223", "\\224", "\\225", "\\226", "\\227", "\\230",
  "\\231", "\\232", "\\233", "\\234", "\\235", "\\236", "\\237", "\\240",
  "\\241", "\\242", "\\243", "\\244", "\\245", "\\246", "\\247", "\\250",
  "\\251", "\\252", "\\253", "\\254", "\\255", "\\256", "\\257", "\\260",
  "\\261", "\\262", "\\263", "\\264", "\\265", "\\266", "\\267", "\\270",
  "\\271", "\\272", "\\273", "\\274", "\\275", "\\276", "\\277", "\\300",
  "\\301", "\\302", "\\303", "\\304", "\\305", "\\306", "\\307", "\\310",
  "\\311", "\\312", "\\313", "\\314", "\\315", "\\316", "\\317", "\\320",
  "\\321", "\\322", "\\323", "\\324", "\\325", "\\326", "\\327", "\\330",
  "\\331", "\\332", "\\333", "\\334", "\\335", "\\336", "\\337", "\\340",
  "\\341", "\\342", "\\343", "\\344", "\\345", "\\346", "\\347", "\\350",
  "\\351", "\\352", "\\353", "\\354", "\\355", "\\356", "\\357", "\\360",
  "\\361", "\\362", "\\363", "\\364", "\\365", "\\366", "\\367", "\\370",
  "\\371", "\\372", "\\373", "\\374", "\\375", "\\376", "\\377")

"fontdemo" <-
function(numbers = c(1, 13, 35))
{
    ##	based on suggestion by Rick Chappell, chappell@stat.wisc.edu
    ##	modified by Alan Zaslavsky, zaslavsk@hustat.harvard.edu
    if(!exists("ps.fonts")) ps.fonts <- ps.options()$fonts
    par(mfrow = c(3, 1))
    txt <- c(letters, "<", ",", "/", "`", 0:9, "-", "=", ";", "'", "[",
             "]", LETTERS, ">", ",", ".", "?", "|", "~", "!", "@", "#",
             "$", "%", "^", "&", "*", "(", ")", "_", "+", ":", "{", "}",
             "", "", "")
    x <- rep(1:16, 6)
    y <- rep(1:6, rep(16, 6))
    for(number in numbers) {
        plot(1:10, 1:10, type = "n", xlab = "", ylab = "",
             xlim = c(0, 17), ylim = c(0.5, 6.5),
             main = paste("Font=", number,
             if(number == 1) "(Default Font)", ps.fonts[number]),
             xaxt = "n", yaxt = "n")
        text(x, y, txt, cex = 2, font = number)
    }
}

"ps.show.fonts" <-
function(font.nrs = c(0, seq(ps.fonts)), extended = T)
{
	# Purpose: Print all the characters of some (default : all) Postscript fonts
	#	   in nice tabular form, two fonts per page
	# Author: Martin Maechler <maechler@stat.math.ethz.ch>, Date:  Mar 27 1992
	# Modified by: Alan Zaslavsky, zaslavsk@hustat.harvard.edu
	# ----------------------------------------------------------------
	#		extended = logical, show ASCII characters above 127 ?
	#		font.nrs = numeric vector; index in ps.fonts, of fonts to use
	# NB : Needs global objects  All.ASCII, All.ASCII.rep
	# ----------------------------------------------------------------
    if(!exists("ps.fonts")) ps.fonts <- ps.options()$fonts
    if(extended) {
### show all ASCII 0-255
        par(mfrow = c(2, 1))
        for(ifont in font.nrs) {
            plot(0:15, 0:15, type = "n", lab = c(20, 20, 7), xlab
                 = "", ylab = "", yaxt = "n", font = 1, main =
                 if(ifont) paste("Postscript font \"", ps.fonts[ifont],
                                 "\";  S font = ", ifont, sep = "")
                 else "S string representation")
            axis(2, at = 15:0, labels = F)
            mtext(paste(15:0 * 16), 2, line = 1, at = 0:15, font = 1)
            abline(h = -0.5 + 4 * 1:3, lty = 2)
            abline(v = 0.5 + 4 * 1:3, lty = 2)
            if(ifont)
                text(rep(0:15, 16), rep(15:0, rep(16, 16)),
                     All.ASCII, cex = 1, font = ifont)
            else text(rep(0:15, 16), rep(15:0, rep(16, 16)),
                      All.ASCII.rep, cex = 0.8, font = 1)
            mtext("Character at (x,y) = ASCII character (x+y) = All.ASCII[x+y+1]",
                  side = 3, line = 0)
        }
    }
    else {
### show only 0-127
        par(mfrow = c(4, 1))
        par(cex = 0.9)
        for(ifont in font.nrs) {
            plot(c(0, 15), c(-0.5, 7.5), type = "n", lab = c(20, 20, 7),
                 xlab = "", ylab = "", yaxt = "n", font = 1,
                 main = if(ifont) paste(
                 "Postscript font \"", ps.fonts[ifont],
                 "\";  S font = ", ifont, sep = "")
                 else "S string representation")
            axis(2, at = 7:0, labels = F)
            mtext(paste(7:0 * 16), 2, line = 1.3, at = 0:7, font = 1)
            abline(v = 0.5 + 4 * 1:3, lty = 2)
            if(ifont)
                text(rep(0:15, 8), rep(7:0, rep(16, 8)),
                     All.ASCII[1:128], cex = 1, font = ifont)
            else text(rep(0:15, 8), rep(7:0, rep(16, 8)),
                      All.ASCII.rep[1:128], cex = 0.8, font = 1)
            mtext("Character at (x,y) = ASCII character (x+y) = All.ASCII[x+y+1]",
                  side = 3, line = 0)
        }
    }
}

